from typing import Any, Optional, List, Dict, Tuple, Callable, Union

class Dex:
    ACCESS_FLAGS: dict
    DEBINFO_LINEINFO: int  # 1
    DEXCMN_DEBINFO: int  # 68
    DEXCMN_DEBSTR: int  # 66
    DEXCMN_METHOD_ID: int  # 77
    DEXCMN_STRING_ID: int  # 83
    DEXCMN_TRY_IDS: int  # 89
    DEXCMN_TRY_TYPES: int  # 69
    DEXVAR_FIELD: int  # 70
    DEXVAR_METHOD: int  # 77
    DEXVAR_METH_STR: int  # 78
    DEXVAR_METH_STRO: int  # 79
    DEXVAR_STRING_IDS: int  # 83
    DEXVAR_TRYLIST: int  # 89
    DEXVAR_TYPE_IDS: int  # 84
    DEXVAR_TYPE_STR: int  # 85
    DEXVAR_TYPE_STRO: int  # 86
    HASHVAL_DEXVERSION: str  # dex_version
    HASHVAL_MAGIC: str  # version
    HASHVAL_OPTIMIZED: str  # optimized
    META_BASEADDRS: int  # 1
    PRIMITVE_TYPES: dict
    def __delattr__(self, name: Any) -> Any: ...
        """Implement delattr(self, name)."""
    def __dir__(self) -> Any: ...
        """Default dir() implementation."""
    def __eq__(self, value: Any) -> Any: ...
        """Return self==value."""
    def __format__(self, format_spec: Any) -> Any: ...
        """Default object formatter."""
    def __ge__(self, value: Any) -> Any: ...
        """Return self>=value."""
    def __getattribute__(self, name: Any) -> Any: ...
        """Return getattr(self, name)."""
    def __gt__(self, value: Any) -> Any: ...
        """Return self>value."""
    def __hash__(self) -> Any: ...
        """Return hash(self)."""
    def __init__(self) -> Any: ...
    def __init_subclass__(self, *args: Any, **kwargs: Any) -> Any: ...
        """This method is called when a class is subclassed.
        
        The default implementation does nothing. It may be
        overridden to extend subclasses.
        
        """
    def __le__(self, value: Any) -> Any: ...
        """Return self<=value."""
    def __lt__(self, value: Any) -> Any: ...
        """Return self<value."""
    def __ne__(self, value: Any) -> Any: ...
        """Return self!=value."""
    def __new__(self, args: Any, kwargs: Any) -> Any: ...
        """Create and return a new object.  See help(type) for accurate signature."""
    def __reduce__(self) -> Any: ...
        """Helper for pickle."""
    def __reduce_ex__(self, protocol: Any) -> Any: ...
        """Helper for pickle."""
    def __repr__(self) -> Any: ...
        """Return repr(self)."""
    def __setattr__(self, name: Any, value: Any) -> Any: ...
        """Implement setattr(self, name, value)."""
    def __sizeof__(self) -> Any: ...
        """Size of object in memory, in bytes."""
    def __str__(self) -> Any: ...
        """Return str(self)."""
    def __subclasshook__(self, *args: Any, **kwargs: Any) -> Any: ...
        """Abstract classes can override this to customize issubclass().
        
        This is invoked early on by abc.ABCMeta.__subclasscheck__().
        It should return True, False or NotImplemented.  If it returns
        NotImplemented, the normal algorithm is used.  Otherwise, it
        overrides the normal algorithm (and the outcome is cached).
        
        """
    def access_string(self, flags: Any) -> Any: ...
    def as_string(self, s: Any) -> Any: ...
    def decorate_java_typename(self, desc: Any) -> Any: ...
    def get_call_method_name(self, method: Any) -> Any: ...
    def get_dexnum(self, from_ea: Any) -> Any: ...
    def get_field(self, from_ea: Any, field_idx: Any) -> Any: ...
    def get_field_name(self, from_ea: Any, field_idx: Any) -> Any: ...
    def get_full_field_name(self, field_idx: Any, field: Any, field_name: Any) -> Any: ...
    def get_full_method_name(self, method: Any) -> Any: ...
    def get_full_type_name(self, longname: Any) -> Any: ...
    def get_method(self, from_ea: Any, method_idx: Any) -> Any: ...
    def get_method_idx(self, ea: Any) -> Any: ...
    def get_method_name(self, from_ea: Any, method_idx: Any) -> Any: ...
    def get_nn_var(self, from_ea: Any) -> Any: ...
    def get_parameter_name(self, from_ea: Any, idx: Any) -> Any: ...
    def get_short_field_name(self, field_idx: Any, field: Any, field_name: Any) -> Any: ...
    def get_short_method_name(self, method: Any) -> Any: ...
    def get_short_type_name(self, longname: Any) -> Any: ...
    def get_string(self, from_ea: Any, string_idx: Any) -> Any: ...
    def get_string_by_index(self, node: Any, idx: Any, tag: Any) -> Any: ...
    def get_type_string(self, from_ea: Any, type_idx: Any) -> Any: ...
    def idx_to_ea(self, from_ea: Any, idx: Any, tag: Any) -> Any: ...
    def is_wide_type(self, typechar: Any) -> Any: ...

class char:
    value: getset_descriptor
    def __bool__(self) -> Any: ...
        """True if self else False"""
    def __ctype_be__(self, *args: Any, **kwargs: Any) -> Any: ...
    def __ctype_le__(self, *args: Any, **kwargs: Any) -> Any: ...
    def __ctypes_from_outparam__(self, *args: Any, **kwargs: Any) -> Any: ...
    def __delattr__(self, name: Any) -> Any: ...
        """Implement delattr(self, name)."""
    def __dir__(self) -> Any: ...
        """Default dir() implementation."""
    def __eq__(self, value: Any) -> Any: ...
        """Return self==value."""
    def __format__(self, format_spec: Any) -> Any: ...
        """Default object formatter."""
    def __ge__(self, value: Any) -> Any: ...
        """Return self>=value."""
    def __getattribute__(self, name: Any) -> Any: ...
        """Return getattr(self, name)."""
    def __gt__(self, value: Any) -> Any: ...
        """Return self>value."""
    def __hash__(self) -> Any: ...
        """Return hash(self)."""
    def __init__(self, args: Any, kwargs: Any) -> Any: ...
        """Initialize self.  See help(type(self)) for accurate signature."""
    def __init_subclass__(self, *args: Any, **kwargs: Any) -> Any: ...
        """This method is called when a class is subclassed.
        
        The default implementation does nothing. It may be
        overridden to extend subclasses.
        
        """
    def __le__(self, value: Any) -> Any: ...
        """Return self<=value."""
    def __lt__(self, value: Any) -> Any: ...
        """Return self<value."""
    def __ne__(self, value: Any) -> Any: ...
        """Return self!=value."""
    def __new__(self, args: Any, kwargs: Any) -> Any: ...
        """Create and return a new object.  See help(type) for accurate signature."""
    def __reduce__(self, *args: Any, **kwargs: Any) -> Any: ...
    def __reduce_ex__(self, protocol: Any) -> Any: ...
        """Helper for pickle."""
    def __repr__(self) -> Any: ...
        """Return repr(self)."""
    def __setattr__(self, name: Any, value: Any) -> Any: ...
        """Implement setattr(self, name, value)."""
    def __setstate__(self, *args: Any, **kwargs: Any) -> Any: ...
    def __sizeof__(self) -> Any: ...
        """Size of object in memory, in bytes."""
    def __str__(self) -> Any: ...
        """Return str(self)."""
    def __subclasshook__(self, *args: Any, **kwargs: Any) -> Any: ...
        """Abstract classes can override this to customize issubclass().
        
        This is invoked early on by abc.ABCMeta.__subclasscheck__().
        It should return True, False or NotImplemented.  If it returns
        NotImplemented, the normal algorithm is used.  Otherwise, it
        overrides the normal algorithm (and the outcome is cached).
        
        """

class dex_field:
    ctype: CField  # <Field type=c_uint, ofs=0, size=4>
    maddr: CField  # <Field type=c_ulong, ofs=16, size=8>
    name: CField  # <Field type=c_uint, ofs=4, size=4>
    type: CField  # <Field type=c_uint, ofs=8, size=4>
    def __ctypes_from_outparam__(self, *args: Any, **kwargs: Any) -> Any: ...
    def __delattr__(self, name: Any) -> Any: ...
        """Implement delattr(self, name)."""
    def __dir__(self) -> Any: ...
        """Default dir() implementation."""
    def __eq__(self, value: Any) -> Any: ...
        """Return self==value."""
    def __format__(self, format_spec: Any) -> Any: ...
        """Default object formatter."""
    def __ge__(self, value: Any) -> Any: ...
        """Return self>=value."""
    def __getattribute__(self, name: Any) -> Any: ...
        """Return getattr(self, name)."""
    def __gt__(self, value: Any) -> Any: ...
        """Return self>value."""
    def __hash__(self) -> Any: ...
        """Return hash(self)."""
    def __init__(self, args: Any, kwargs: Any) -> Any: ...
        """Initialize self.  See help(type(self)) for accurate signature."""
    def __init_subclass__(self, *args: Any, **kwargs: Any) -> Any: ...
        """This method is called when a class is subclassed.
        
        The default implementation does nothing. It may be
        overridden to extend subclasses.
        
        """
    def __le__(self, value: Any) -> Any: ...
        """Return self<=value."""
    def __lt__(self, value: Any) -> Any: ...
        """Return self<value."""
    def __ne__(self, value: Any) -> Any: ...
        """Return self!=value."""
    def __new__(self, args: Any, kwargs: Any) -> Any: ...
        """Create and return a new object.  See help(type) for accurate signature."""
    def __reduce__(self, *args: Any, **kwargs: Any) -> Any: ...
    def __reduce_ex__(self, protocol: Any) -> Any: ...
        """Helper for pickle."""
    def __repr__(self) -> Any: ...
        """Return repr(self)."""
    def __setattr__(self, name: Any, value: Any) -> Any: ...
        """Implement setattr(self, name, value)."""
    def __setstate__(self, *args: Any, **kwargs: Any) -> Any: ...
    def __sizeof__(self) -> Any: ...
        """Size of object in memory, in bytes."""
    def __str__(self) -> Any: ...
        """Return str(self)."""
    def __subclasshook__(self, *args: Any, **kwargs: Any) -> Any: ...
        """Abstract classes can override this to customize issubclass().
        
        This is invoked early on by abc.ABCMeta.__subclasscheck__().
        It should return True, False or NotImplemented.  If it returns
        NotImplemented, the normal algorithm is used.  Otherwise, it
        overrides the normal algorithm (and the outcome is cached).
        
        """

class dex_method:
    HAS_CODE: int  # 2
    IS_LOCAL: int  # 1
    access_flags: CField  # <Field type=c_uint, ofs=164, size=4>
    catchHData: CField  # <Field type=c_ulong, ofs=192, size=8>
    cname: CField  # <Field type=c_uint, ofs=16, size=4>
    defaddr: CField  # <Field type=c_ulong, ofs=8, size=8>
    endAddr: CField  # <Field type=c_ulong, ofs=176, size=8>
    flags: CField  # <Field type=c_uint, ofs=0, size=4>
    id: CField  # <Field type=c_uint, ofs=20, size=4>
    nparams: CField  # <Field type=c_ushort, ofs=32, size=2>
    proto_params: CField  # <Field type=c_uint_Array_32, ofs=36, size=128>
    proto_ret: CField  # <Field type=c_uint, ofs=24, size=4>
    proto_shorty: CField  # <Field type=c_uint, ofs=28, size=4>
    reg_out: CField  # <Field type=c_ushort, ofs=188, size=2>
    reg_params: CField  # <Field type=c_ushort, ofs=186, size=2>
    reg_total: CField  # <Field type=c_ushort, ofs=184, size=2>
    startAddr: CField  # <Field type=c_ulong, ofs=168, size=8>
    def __ctypes_from_outparam__(self, *args: Any, **kwargs: Any) -> Any: ...
    def __delattr__(self, name: Any) -> Any: ...
        """Implement delattr(self, name)."""
    def __dir__(self) -> Any: ...
        """Default dir() implementation."""
    def __eq__(self, value: Any) -> Any: ...
        """Return self==value."""
    def __format__(self, format_spec: Any) -> Any: ...
        """Default object formatter."""
    def __ge__(self, value: Any) -> Any: ...
        """Return self>=value."""
    def __getattribute__(self, name: Any) -> Any: ...
        """Return getattr(self, name)."""
    def __gt__(self, value: Any) -> Any: ...
        """Return self>value."""
    def __hash__(self) -> Any: ...
        """Return hash(self)."""
    def __init__(self, args: Any, kwargs: Any) -> Any: ...
        """Initialize self.  See help(type(self)) for accurate signature."""
    def __init_subclass__(self, *args: Any, **kwargs: Any) -> Any: ...
        """This method is called when a class is subclassed.
        
        The default implementation does nothing. It may be
        overridden to extend subclasses.
        
        """
    def __le__(self, value: Any) -> Any: ...
        """Return self<=value."""
    def __lt__(self, value: Any) -> Any: ...
        """Return self<value."""
    def __ne__(self, value: Any) -> Any: ...
        """Return self!=value."""
    def __new__(self, args: Any, kwargs: Any) -> Any: ...
        """Create and return a new object.  See help(type) for accurate signature."""
    def __reduce__(self, *args: Any, **kwargs: Any) -> Any: ...
    def __reduce_ex__(self, protocol: Any) -> Any: ...
        """Helper for pickle."""
    def __repr__(self) -> Any: ...
        """Return repr(self)."""
    def __setattr__(self, name: Any, value: Any) -> Any: ...
        """Implement setattr(self, name, value)."""
    def __setstate__(self, *args: Any, **kwargs: Any) -> Any: ...
    def __sizeof__(self) -> Any: ...
        """Size of object in memory, in bytes."""
    def __str__(self) -> Any: ...
        """Return str(self)."""
    def __subclasshook__(self, *args: Any, **kwargs: Any) -> Any: ...
        """Abstract classes can override this to customize issubclass().
        
        This is invoked early on by abc.ABCMeta.__subclasscheck__().
        It should return True, False or NotImplemented.  If it returns
        NotImplemented, the normal algorithm is used.  Otherwise, it
        overrides the normal algorithm (and the outcome is cached).
        
        """
    def is_local(self) -> Any: ...

class ea_t:
    value: getset_descriptor
    def __bool__(self) -> Any: ...
        """True if self else False"""
    def __ctype_be__(self, *args: Any, **kwargs: Any) -> Any: ...
    def __ctype_le__(self, *args: Any, **kwargs: Any) -> Any: ...
    def __ctypes_from_outparam__(self, *args: Any, **kwargs: Any) -> Any: ...
    def __delattr__(self, name: Any) -> Any: ...
        """Implement delattr(self, name)."""
    def __dir__(self) -> Any: ...
        """Default dir() implementation."""
    def __eq__(self, value: Any) -> Any: ...
        """Return self==value."""
    def __format__(self, format_spec: Any) -> Any: ...
        """Default object formatter."""
    def __ge__(self, value: Any) -> Any: ...
        """Return self>=value."""
    def __getattribute__(self, name: Any) -> Any: ...
        """Return getattr(self, name)."""
    def __gt__(self, value: Any) -> Any: ...
        """Return self>value."""
    def __hash__(self) -> Any: ...
        """Return hash(self)."""
    def __init__(self, args: Any, kwargs: Any) -> Any: ...
        """Initialize self.  See help(type(self)) for accurate signature."""
    def __init_subclass__(self, *args: Any, **kwargs: Any) -> Any: ...
        """This method is called when a class is subclassed.
        
        The default implementation does nothing. It may be
        overridden to extend subclasses.
        
        """
    def __le__(self, value: Any) -> Any: ...
        """Return self<=value."""
    def __lt__(self, value: Any) -> Any: ...
        """Return self<value."""
    def __ne__(self, value: Any) -> Any: ...
        """Return self!=value."""
    def __new__(self, args: Any, kwargs: Any) -> Any: ...
        """Create and return a new object.  See help(type) for accurate signature."""
    def __reduce__(self, *args: Any, **kwargs: Any) -> Any: ...
    def __reduce_ex__(self, protocol: Any) -> Any: ...
        """Helper for pickle."""
    def __repr__(self) -> Any: ...
        """Return repr(self)."""
    def __setattr__(self, name: Any, value: Any) -> Any: ...
        """Implement setattr(self, name, value)."""
    def __setstate__(self, *args: Any, **kwargs: Any) -> Any: ...
    def __sizeof__(self) -> Any: ...
        """Size of object in memory, in bytes."""
    def __str__(self) -> Any: ...
        """Return str(self)."""
    def __subclasshook__(self, *args: Any, **kwargs: Any) -> Any: ...
        """Abstract classes can override this to customize issubclass().
        
        This is invoked early on by abc.ABCMeta.__subclasscheck__().
        It should return True, False or NotImplemented.  If it returns
        NotImplemented, the normal algorithm is used.  Otherwise, it
        overrides the normal algorithm (and the outcome is cached).
        
        """

class longname_director_t:
    node: CField  # <Field type=c_ulong, ofs=1, size=8>
    zero: CField  # <Field type=c_ubyte, ofs=0, size=1>
    def __ctypes_from_outparam__(self, *args: Any, **kwargs: Any) -> Any: ...
    def __delattr__(self, name: Any) -> Any: ...
        """Implement delattr(self, name)."""
    def __dir__(self) -> Any: ...
        """Default dir() implementation."""
    def __eq__(self, value: Any) -> Any: ...
        """Return self==value."""
    def __format__(self, format_spec: Any) -> Any: ...
        """Default object formatter."""
    def __ge__(self, value: Any) -> Any: ...
        """Return self>=value."""
    def __getattribute__(self, name: Any) -> Any: ...
        """Return getattr(self, name)."""
    def __gt__(self, value: Any) -> Any: ...
        """Return self>value."""
    def __hash__(self) -> Any: ...
        """Return hash(self)."""
    def __init__(self, args: Any, kwargs: Any) -> Any: ...
        """Initialize self.  See help(type(self)) for accurate signature."""
    def __init_subclass__(self, *args: Any, **kwargs: Any) -> Any: ...
        """This method is called when a class is subclassed.
        
        The default implementation does nothing. It may be
        overridden to extend subclasses.
        
        """
    def __le__(self, value: Any) -> Any: ...
        """Return self<=value."""
    def __lt__(self, value: Any) -> Any: ...
        """Return self<value."""
    def __ne__(self, value: Any) -> Any: ...
        """Return self!=value."""
    def __new__(self, args: Any, kwargs: Any) -> Any: ...
        """Create and return a new object.  See help(type) for accurate signature."""
    def __reduce__(self, *args: Any, **kwargs: Any) -> Any: ...
    def __reduce_ex__(self, protocol: Any) -> Any: ...
        """Helper for pickle."""
    def __repr__(self) -> Any: ...
        """Return repr(self)."""
    def __setattr__(self, name: Any, value: Any) -> Any: ...
        """Implement setattr(self, name, value)."""
    def __setstate__(self, *args: Any, **kwargs: Any) -> Any: ...
    def __sizeof__(self) -> Any: ...
        """Size of object in memory, in bytes."""
    def __str__(self) -> Any: ...
        """Return str(self)."""
    def __subclasshook__(self, *args: Any, **kwargs: Any) -> Any: ...
        """Abstract classes can override this to customize issubclass().
        
        This is invoked early on by abc.ABCMeta.__subclasscheck__().
        It should return True, False or NotImplemented.  If it returns
        NotImplemented, the normal algorithm is used.  Otherwise, it
        overrides the normal algorithm (and the outcome is cached).
        
        """

class uint16:
    value: getset_descriptor
    def __bool__(self) -> Any: ...
        """True if self else False"""
    def __ctype_be__(self, *args: Any, **kwargs: Any) -> Any: ...
    def __ctype_le__(self, *args: Any, **kwargs: Any) -> Any: ...
    def __ctypes_from_outparam__(self, *args: Any, **kwargs: Any) -> Any: ...
    def __delattr__(self, name: Any) -> Any: ...
        """Implement delattr(self, name)."""
    def __dir__(self) -> Any: ...
        """Default dir() implementation."""
    def __eq__(self, value: Any) -> Any: ...
        """Return self==value."""
    def __format__(self, format_spec: Any) -> Any: ...
        """Default object formatter."""
    def __ge__(self, value: Any) -> Any: ...
        """Return self>=value."""
    def __getattribute__(self, name: Any) -> Any: ...
        """Return getattr(self, name)."""
    def __gt__(self, value: Any) -> Any: ...
        """Return self>value."""
    def __hash__(self) -> Any: ...
        """Return hash(self)."""
    def __init__(self, args: Any, kwargs: Any) -> Any: ...
        """Initialize self.  See help(type(self)) for accurate signature."""
    def __init_subclass__(self, *args: Any, **kwargs: Any) -> Any: ...
        """This method is called when a class is subclassed.
        
        The default implementation does nothing. It may be
        overridden to extend subclasses.
        
        """
    def __le__(self, value: Any) -> Any: ...
        """Return self<=value."""
    def __lt__(self, value: Any) -> Any: ...
        """Return self<value."""
    def __ne__(self, value: Any) -> Any: ...
        """Return self!=value."""
    def __new__(self, args: Any, kwargs: Any) -> Any: ...
        """Create and return a new object.  See help(type) for accurate signature."""
    def __reduce__(self, *args: Any, **kwargs: Any) -> Any: ...
    def __reduce_ex__(self, protocol: Any) -> Any: ...
        """Helper for pickle."""
    def __repr__(self) -> Any: ...
        """Return repr(self)."""
    def __setattr__(self, name: Any, value: Any) -> Any: ...
        """Implement setattr(self, name, value)."""
    def __setstate__(self, *args: Any, **kwargs: Any) -> Any: ...
    def __sizeof__(self) -> Any: ...
        """Size of object in memory, in bytes."""
    def __str__(self) -> Any: ...
        """Return str(self)."""
    def __subclasshook__(self, *args: Any, **kwargs: Any) -> Any: ...
        """Abstract classes can override this to customize issubclass().
        
        This is invoked early on by abc.ABCMeta.__subclasscheck__().
        It should return True, False or NotImplemented.  If it returns
        NotImplemented, the normal algorithm is used.  Otherwise, it
        overrides the normal algorithm (and the outcome is cached).
        
        """

class uint32:
    value: getset_descriptor
    def __bool__(self) -> Any: ...
        """True if self else False"""
    def __ctype_be__(self, *args: Any, **kwargs: Any) -> Any: ...
    def __ctype_le__(self, *args: Any, **kwargs: Any) -> Any: ...
    def __ctypes_from_outparam__(self, *args: Any, **kwargs: Any) -> Any: ...
    def __delattr__(self, name: Any) -> Any: ...
        """Implement delattr(self, name)."""
    def __dir__(self) -> Any: ...
        """Default dir() implementation."""
    def __eq__(self, value: Any) -> Any: ...
        """Return self==value."""
    def __format__(self, format_spec: Any) -> Any: ...
        """Default object formatter."""
    def __ge__(self, value: Any) -> Any: ...
        """Return self>=value."""
    def __getattribute__(self, name: Any) -> Any: ...
        """Return getattr(self, name)."""
    def __gt__(self, value: Any) -> Any: ...
        """Return self>value."""
    def __hash__(self) -> Any: ...
        """Return hash(self)."""
    def __init__(self, args: Any, kwargs: Any) -> Any: ...
        """Initialize self.  See help(type(self)) for accurate signature."""
    def __init_subclass__(self, *args: Any, **kwargs: Any) -> Any: ...
        """This method is called when a class is subclassed.
        
        The default implementation does nothing. It may be
        overridden to extend subclasses.
        
        """
    def __le__(self, value: Any) -> Any: ...
        """Return self<=value."""
    def __lt__(self, value: Any) -> Any: ...
        """Return self<value."""
    def __ne__(self, value: Any) -> Any: ...
        """Return self!=value."""
    def __new__(self, args: Any, kwargs: Any) -> Any: ...
        """Create and return a new object.  See help(type) for accurate signature."""
    def __reduce__(self, *args: Any, **kwargs: Any) -> Any: ...
    def __reduce_ex__(self, protocol: Any) -> Any: ...
        """Helper for pickle."""
    def __repr__(self) -> Any: ...
        """Return repr(self)."""
    def __setattr__(self, name: Any, value: Any) -> Any: ...
        """Implement setattr(self, name, value)."""
    def __setstate__(self, *args: Any, **kwargs: Any) -> Any: ...
    def __sizeof__(self) -> Any: ...
        """Size of object in memory, in bytes."""
    def __str__(self) -> Any: ...
        """Return str(self)."""
    def __subclasshook__(self, *args: Any, **kwargs: Any) -> Any: ...
        """Abstract classes can override this to customize issubclass().
        
        This is invoked early on by abc.ABCMeta.__subclasscheck__().
        It should return True, False or NotImplemented.  If it returns
        NotImplemented, the normal algorithm is used.  Otherwise, it
        overrides the normal algorithm (and the outcome is cached).
        
        """

class uint64:
    value: getset_descriptor
    def __bool__(self) -> Any: ...
        """True if self else False"""
    def __ctype_be__(self, *args: Any, **kwargs: Any) -> Any: ...
    def __ctype_le__(self, *args: Any, **kwargs: Any) -> Any: ...
    def __ctypes_from_outparam__(self, *args: Any, **kwargs: Any) -> Any: ...
    def __delattr__(self, name: Any) -> Any: ...
        """Implement delattr(self, name)."""
    def __dir__(self) -> Any: ...
        """Default dir() implementation."""
    def __eq__(self, value: Any) -> Any: ...
        """Return self==value."""
    def __format__(self, format_spec: Any) -> Any: ...
        """Default object formatter."""
    def __ge__(self, value: Any) -> Any: ...
        """Return self>=value."""
    def __getattribute__(self, name: Any) -> Any: ...
        """Return getattr(self, name)."""
    def __gt__(self, value: Any) -> Any: ...
        """Return self>value."""
    def __hash__(self) -> Any: ...
        """Return hash(self)."""
    def __init__(self, args: Any, kwargs: Any) -> Any: ...
        """Initialize self.  See help(type(self)) for accurate signature."""
    def __init_subclass__(self, *args: Any, **kwargs: Any) -> Any: ...
        """This method is called when a class is subclassed.
        
        The default implementation does nothing. It may be
        overridden to extend subclasses.
        
        """
    def __le__(self, value: Any) -> Any: ...
        """Return self<=value."""
    def __lt__(self, value: Any) -> Any: ...
        """Return self<value."""
    def __ne__(self, value: Any) -> Any: ...
        """Return self!=value."""
    def __new__(self, args: Any, kwargs: Any) -> Any: ...
        """Create and return a new object.  See help(type) for accurate signature."""
    def __reduce__(self, *args: Any, **kwargs: Any) -> Any: ...
    def __reduce_ex__(self, protocol: Any) -> Any: ...
        """Helper for pickle."""
    def __repr__(self) -> Any: ...
        """Return repr(self)."""
    def __setattr__(self, name: Any, value: Any) -> Any: ...
        """Implement setattr(self, name, value)."""
    def __setstate__(self, *args: Any, **kwargs: Any) -> Any: ...
    def __sizeof__(self) -> Any: ...
        """Size of object in memory, in bytes."""
    def __str__(self) -> Any: ...
        """Return str(self)."""
    def __subclasshook__(self, *args: Any, **kwargs: Any) -> Any: ...
        """Abstract classes can override this to customize issubclass().
        
        This is invoked early on by abc.ABCMeta.__subclasscheck__().
        It should return True, False or NotImplemented.  If it returns
        NotImplemented, the normal algorithm is used.  Otherwise, it
        overrides the normal algorithm (and the outcome is cached).
        
        """

class uint8:
    value: getset_descriptor
    def __bool__(self) -> Any: ...
        """True if self else False"""
    def __ctype_be__(self, *args: Any, **kwargs: Any) -> Any: ...
    def __ctype_le__(self, *args: Any, **kwargs: Any) -> Any: ...
    def __ctypes_from_outparam__(self, *args: Any, **kwargs: Any) -> Any: ...
    def __delattr__(self, name: Any) -> Any: ...
        """Implement delattr(self, name)."""
    def __dir__(self) -> Any: ...
        """Default dir() implementation."""
    def __eq__(self, value: Any) -> Any: ...
        """Return self==value."""
    def __format__(self, format_spec: Any) -> Any: ...
        """Default object formatter."""
    def __ge__(self, value: Any) -> Any: ...
        """Return self>=value."""
    def __getattribute__(self, name: Any) -> Any: ...
        """Return getattr(self, name)."""
    def __gt__(self, value: Any) -> Any: ...
        """Return self>value."""
    def __hash__(self) -> Any: ...
        """Return hash(self)."""
    def __init__(self, args: Any, kwargs: Any) -> Any: ...
        """Initialize self.  See help(type(self)) for accurate signature."""
    def __init_subclass__(self, *args: Any, **kwargs: Any) -> Any: ...
        """This method is called when a class is subclassed.
        
        The default implementation does nothing. It may be
        overridden to extend subclasses.
        
        """
    def __le__(self, value: Any) -> Any: ...
        """Return self<=value."""
    def __lt__(self, value: Any) -> Any: ...
        """Return self<value."""
    def __ne__(self, value: Any) -> Any: ...
        """Return self!=value."""
    def __new__(self, args: Any, kwargs: Any) -> Any: ...
        """Create and return a new object.  See help(type) for accurate signature."""
    def __reduce__(self, *args: Any, **kwargs: Any) -> Any: ...
    def __reduce_ex__(self, protocol: Any) -> Any: ...
        """Helper for pickle."""
    def __repr__(self) -> Any: ...
        """Return repr(self)."""
    def __setattr__(self, name: Any, value: Any) -> Any: ...
        """Implement setattr(self, name, value)."""
    def __setstate__(self, *args: Any, **kwargs: Any) -> Any: ...
    def __sizeof__(self) -> Any: ...
        """Size of object in memory, in bytes."""
    def __str__(self) -> Any: ...
        """Return str(self)."""
    def __subclasshook__(self, *args: Any, **kwargs: Any) -> Any: ...
        """Abstract classes can override this to customize issubclass().
        
        This is invoked early on by abc.ABCMeta.__subclasscheck__().
        It should return True, False or NotImplemented.  If it returns
        NotImplemented, the normal algorithm is used.  Otherwise, it
        overrides the normal algorithm (and the outcome is cached).
        
        """

class ushort:
    value: getset_descriptor
    def __bool__(self) -> Any: ...
        """True if self else False"""
    def __ctype_be__(self, *args: Any, **kwargs: Any) -> Any: ...
    def __ctype_le__(self, *args: Any, **kwargs: Any) -> Any: ...
    def __ctypes_from_outparam__(self, *args: Any, **kwargs: Any) -> Any: ...
    def __delattr__(self, name: Any) -> Any: ...
        """Implement delattr(self, name)."""
    def __dir__(self) -> Any: ...
        """Default dir() implementation."""
    def __eq__(self, value: Any) -> Any: ...
        """Return self==value."""
    def __format__(self, format_spec: Any) -> Any: ...
        """Default object formatter."""
    def __ge__(self, value: Any) -> Any: ...
        """Return self>=value."""
    def __getattribute__(self, name: Any) -> Any: ...
        """Return getattr(self, name)."""
    def __gt__(self, value: Any) -> Any: ...
        """Return self>value."""
    def __hash__(self) -> Any: ...
        """Return hash(self)."""
    def __init__(self, args: Any, kwargs: Any) -> Any: ...
        """Initialize self.  See help(type(self)) for accurate signature."""
    def __init_subclass__(self, *args: Any, **kwargs: Any) -> Any: ...
        """This method is called when a class is subclassed.
        
        The default implementation does nothing. It may be
        overridden to extend subclasses.
        
        """
    def __le__(self, value: Any) -> Any: ...
        """Return self<=value."""
    def __lt__(self, value: Any) -> Any: ...
        """Return self<value."""
    def __ne__(self, value: Any) -> Any: ...
        """Return self!=value."""
    def __new__(self, args: Any, kwargs: Any) -> Any: ...
        """Create and return a new object.  See help(type) for accurate signature."""
    def __reduce__(self, *args: Any, **kwargs: Any) -> Any: ...
    def __reduce_ex__(self, protocol: Any) -> Any: ...
        """Helper for pickle."""
    def __repr__(self) -> Any: ...
        """Return repr(self)."""
    def __setattr__(self, name: Any, value: Any) -> Any: ...
        """Implement setattr(self, name, value)."""
    def __setstate__(self, *args: Any, **kwargs: Any) -> Any: ...
    def __sizeof__(self) -> Any: ...
        """Size of object in memory, in bytes."""
    def __str__(self) -> Any: ...
        """Return str(self)."""
    def __subclasshook__(self, *args: Any, **kwargs: Any) -> Any: ...
        """Abstract classes can override this to customize issubclass().
        
        This is invoked early on by abc.ABCMeta.__subclasscheck__().
        It should return True, False or NotImplemented.  If it returns
        NotImplemented, the normal algorithm is used.  Otherwise, it
        overrides the normal algorithm (and the outcome is cached).
        
        """

def get_dw(buf: Any, off: Any) -> Any: ...

def get_struct(str_: Any, off: Any, struct: Any) -> Any: ...

def to_uint32(v: Any) -> Any: ...

def unpack_db(buf: Any, off: Any) -> Any: ...

def unpack_dd(buf: Any, off: Any) -> Any: ...

def unpack_dq(buf: Any, off: Any) -> Any: ...

def unpack_dw(buf: Any, off: Any) -> Any: ...

def unpack_ea(buf: Any, off: Any) -> Any: ...

def unpack_eavec(buf: Any, base_ea: Any) -> Any: ...

ctypes: module
ida_bytes: module
ida_idaapi: module
idaapi: module
idc: _module_wrapper_t
print_function: _Feature
sys: module  # <module 'sys' (built-in)>